<?php 
/**
 * Cálculos estadísticos (Resultado 2) repaso_2b.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2009 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2009-04-27
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Cálculos estadísticos (Resultado 2). Repaso 1. Ejercicios. 
  PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>
<body>

<h1>Cálculos estadísticos (Resultado 2)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? trim(strip_tags($_REQUEST[$var])) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    return $tmp;
}

function recogeMatriz($var) 
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $valor) {
            $tmp = trim(strip_tags($indice));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $tmp = str_replace('&', '&amp;',  $tmp);
            $tmp = str_replace('"', '&quot;', $tmp);
            $indiceLimpio = $tmp;

            $tmp = trim(strip_tags($valor));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $tmp = str_replace('&', '&amp;',  $tmp);
            $tmp = str_replace('"', '&quot;', $tmp);
            $valorLimpio  = $tmp;

            $tmpMatriz[$indiceLimpio] = $valorLimpio;
        }
    }
    return $tmpMatriz;
}

define('FORM_METHOD', 'get');
define('NUM_MINIMO',  1);
define('NUM_MAXIMO',  20);

$numeros      = recogeMatriz('n');
$numerosOk    = FALSE;
$suma   = (recoge('suma')=='on');
$media  = (recoge('media')=='on');
$maximo = (recoge('maximo')=='on');
$minimo = (recoge('minimo')=='on');
$numerosRecibidos = count($numeros);

$numerosOk = TRUE;
foreach ($numeros as $valor) {
    if (!is_numeric($valor)) {
        $numerosOk = FALSE;
    }
}
   
if (!$numerosOk) {
    print "<p style=\"color:red\">Los datos recibidos no son correctos.</p>\n";
} elseif ($numerosRecibidos==0) {
    print "<p>No ha indicado ningún valor.</p>";
} elseif ($numerosRecibidos>NUM_MAXIMO) {
    print "<p style=\"color:red\">El número de valores debe estar entre "
        .NUM_MINIMO." y ".NUM_MAXIMO.".</p>\n";
} else {
    $sumaTotal = 0;
    print "<p>Ha introducido $numerosRecibidos valores: <strong>";
    foreach ($numeros as $valor) {
        print "$valor ";
        $sumaTotal += $valor;
    }
    print "</strong></p>\n";
    if ($suma) {
        print "<p>La suma de los valores es <strong>$sumaTotal</strong>.</p>\n";
    }
    if ($media) {
        print "<p>La media de los valores es <strong>"
            .round($sumaTotal/$numerosRecibidos, 2)."</strong>.</p>\n";
    }
    if ($maximo) {
        print "<p>El valor más grande es <strong>".max($numeros)."</strong>.</p>\n";
    }
    if ($minimo) {
        print "<p>El valor más pequeño es <strong>".min($numeros)."</strong>.</p>\n";
    }    
}

print "<p><a href=\"repaso_3.html\">Volver al formulario inicial.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 27 de abril de 2009
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>